//
// NullDhtEngine.cs
//
// Authors:
//   Alan McGovern alan.mcgovern@gmail.com
//
// Copyright (C) 2009 Alan McGovern
//
// Permission is hereby granted, free of charge, to any person obtaining
// a copy of this software and associated documentation files (the
// "Software"), to deal in the Software without restriction, including
// without limitation the rights to use, copy, modify, merge, publish,
// distribute, sublicense, and/or sell copies of the Software, and to
// permit persons to whom the Software is furnished to do so, subject to
// the following conditions:
// 
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
// LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
// OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
// WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
//

#if !DISABLE_DHT

namespace MonoTorrent.Client
{
    using System;
    using System.Collections.Generic;
    using System.Text;
    using MonoTorrent.BEncoding;
    using MonoTorrent.Common;

    class NullDhtEngine : IDhtEngine
    {
        public event EventHandler<PeersFoundEventArgs> PeersFound
        {
            add{}
            remove{}
        }

        public event EventHandler StateChanged
        {
            add{}
            remove{}
        }

        public bool Disposed
        {
            get { return false; }
        }

        public DhtState State
        {
            get { return DhtState.NotReady; }
        }

        public void Add(BEncodedList nodes)
        {
            
        }

        public void Announce(InfoHash infohash, int port)
        {

        }

        public void Dispose()
        {

        }

        public void GetPeers(InfoHash infohash)
        {

        }

        public byte[] SaveNodes()
        {
            return new byte[0];
        }

        public int CountNodes()
        {
            return 0;
        }

        public void Start()
        {
            
        }

        public void Start(byte[] initialNodes)
        {
            
        }

        public void Stop()
        {
            
        }
    }
}
#endif
